/****************************************************************************
** File name    :  HTError.h
** Description  :  define error code
** Create date  :  2018.09.01
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyright (C) 2002-2018 xi'an huatek, Inc Co., Ltd
** Update record:  
** DATE         AUTHER   DESC 
** -------------------------------------------------------------------------               
** 2018.09.01   Liuyx    first build
****************************************************************************/
#ifndef __HT_ERROR_H
#define __HT_ERROR_H

#define  RET_OK                    0 
#define  RET_FAIL                  -1 
#define  RET_IPPORT_INVALID        -2   // IPַ˿Ч
#define  RET_UDP_BIND_PORT         -3   // UDP󶨶˿ڴ
#define  RET_LENGTH_INVALID        -4   // ݳЧ
#define  RET_VALUE_INVALID         -5   // ֵЧ
#define  RET_TYPE_INVALID          -6   // ҵЧ
#define  RET_CALLOC_FAIL           -7   // ڴʧ
#define  RET_SUB_ID_INVALID        -8   // IDʶЧ/ֵ֧IDʶ
#define  RET_CALL_OCI_FAILED       -9   // OCIʧ
#define  RET_NOT_FOUND_RECORD      -10  // ԭҵˮ
#define  RET_ERROR_AUTHID          -11  // Ч
#define  RET_UDP_STATUS_EXP        -12  // UDP״̬쳣
#define  RET_NOT_EXTERN_PACK       -13  // չ
#define  RET_NOT_FOUND_ACCESSID    -14  // ûм      
#define  RET_TERM_NOT_ONLINE       -15  // ն˲
#define  RET_SUB_COMMAND_INVALID   -16  // ɼݵЧ
#define  RET_MAJOR_CONN_ERR        -17  // TCP·״̬
#define  RET_NOT_FILE_EXIST        -18  // ļ
#define  RET_NOT_DATA              -19  // ɼʻ¼
#define  RET_SET_ERROR_PIC         -20  // ·ָ¼ʧ
#define  RET_SERVER_ID_ERR         -21  // ӷЧ
#define  RET_JT809_VERSION         -22  // ݿЧJT809Э汾
#define  RET_JT808_VERSION         -23  // 808ڲЭЧ
#define  RET_JT809_CRC_ERROR       -24  // CRC16У
#define  RET_LINK_CHECK_ERROR      -25  // ·У
#define  RET_RECORD_ORG_ID_NULL    -26  // ¼IDҵIDΪ
#endif // end __HT_ERROR_H

