/****************************************************************************
** File name    :  HTIEC61850CSGFile.h
** Description  :  йϷι˾(CSG)-㶫ι˾豸߼ϵͳ
**               ͨżҪV1.5(2014-12).--ͼļ
** Create date  :  2019.09.01
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyright (C) 2002-2019 xi'an huatek, Inc Co., Ltd
** Update record:
** DATE         AUTHER   DESC
** -------------------------------------------------------------------------
** 2019.09.01   Liuyx    first build
****************************************************************************/
#ifndef __HT_IEC_61850_CSGFILE_H
#define __HT_IEC_61850_CSGFILE_H

#if defined (__cplusplus)
extern "C" {
#endif /* defined (__cplusplus) */

#pragma pack (push ,1)

    /************************************************************************************
    * ļ׼㶫ι˾豸߼ϵͳ-ͨżҪV1.5(2014.12)
    * ¼A:
    * A.3  ͼļ
    * ͼļԼΪ߼_ұ_ͼͱ_ʱ.dat
    * ߼롢ұ롢ͼͱ룺ո¼B
    * ڴʱ䣺ʽΪYYYYMMDDhhmmss
    * YYYY4λݣ2010
    * MM2λ·ݣ01-12
    * DD2λڣ01-31
    * hh2λСʱ00-23
    * mm2λķӣ00-59
    * ss2λ00-59
    * ʾ0312B12000042 A384 000001_001_01_20100818151010.dat
    ------------------------------------------------------------------------------------
    * ¼B:
    * B.3 վ 
    *       վƵΨһ룬Q/CSG11801.8.1-2008  Ϸ豸Ϣ롷й涨
    *    ĳվλñǰ13λ 
    * B.4 ұ 
    *    ߼װóƵ3λ룬B.1ʾ
    * B.5 ߼
    *       ߼װùλõ23λ룬ɡ13λվ+4λ߼װͱ+6
    *    λšɣñԶĸʵ
    * B.6 ߼װͱ
    *    ߼װ͵4λ룬B.2ʾ
    * B.7 ͼͱ
    *    ߼ͼ͵2λ룬B.3ʾ
    *     B.3ͼͱ
    *    ͼ           
    *    ֲŵͼ        01
    *    ·ͼ      02
    *    ܽͼ  07
    ------------------------------------------------------------------------------------
    * ¼D:
    * D.2 ļʽҪ 
    * a)  ļӦöݸʽд洢ֽΪСֽLittle-Endianλֽ
    *     ŷڵ͵ַˡλֽŷڸߵַˣ 
    * b)  ļӦݺͼ֣֮һָ$$$$0x24242424 
    * c)  ΪļԣݲеĿѡδʹãռλã
    *     λȫΪ14ֽڵfloatӦΪ0xFFFFFFFF 
    * d) ͷΪͺ;ۺͣ 
    *     ٻͣD.1ʾ 
    *        D.1 
    *                             ȡֵΧ 
    *         char          1ֽ         ASCIIʽڵһַ'0''1'
    *                                      'A''B''a''b' '$''#''@' 
    *         byte          1ֽ         -2^7~2^7-1-128~127 
    *         short         2ֽ         -2^15~2^15-1 
    *         int           4ֽ         -2^31~2^31-1 
    *         long          8ֽ         -2^63~2^63-1 
    *         float         4ֽ         -2^128~2^128 
    *         double        8ֽ         -2^1024~2^1024 
    *     ע1charbyteʾ1charֵΪ0x31byteֵΪ0x01 
    * 
    *     ھۺͰ飨arrayṹ壨structȡ 
    * e)  ļеunicode룻
    ************************************************************************************
    D.3 ļҪ
        a) ֲŵ߼װðÿ1㣨1ֲŵͼļӦڱ
        豸ֲܷŵļʱΪ5 - 15ӣ
        b) ѹܽ߼װðÿ1㣨1ܽͼ
        ӦļʱΪ2Сʱ
        c) ·߼װӦ3ݺϲ1·ͼļͬ͵ͼӦ
        ɣӦڶ·жļ
        d) Ϊʵʱļͨ״̬߼װδκͼļڴ
        賿0Զɲõʱļļֻݣذͼݣ
        e) ͼļļСװļΪ60ഫϲϵͳɸװ
        ˻ȷޣļСΪ500KBļӦʱȺѭ洢
    ************************************************************************************/
    
#define CSG_NOT_USE_VALUE       0xFFFFFFFF       // float ͵ֵЧ-δʹ
#define CSG_SPECTROGRAM_PRPD    0x30             // άͼ
#define CSG_SPECTROGRAM_PRPS    0x31             // άͼ

    /*
    * ַļݸʽ ¼D.2
    */
    typedef struct _CSG_PDFILE_HEAD{
        float     fStandardVersion;    // 淶汾,ʹõͨøʽ淶汾ţҪΪ1.2
        float     fFileVersion;        // ļ汾,߼װóڲʹõİ汾ţ
                                       // 1.000ע淶汾
        short     shSpectrogramCode;   // ͼͱ,01:ַ 02:· 07:ܽͼ
        tint64    ilSpectrogramGenTime;// ͼʱ,YYYYMMDDhhmmss
        char      cTestFileFlag;       // ļ־λ,0:ļ 1:ǲļ(ַļ)
        char      szChannleName[32];   //ͨ,unicode,0x00
        char      cFdType;             // ŵ:01˷ŵ磻2ŵ磻3ŵ磻4ڲŵ磻5ŵ磻6ⲿţ7
        char      cWarnLevel;          // ȼ,0ʾ1ʾ12ʾ23ʾ3УΪ3;ԽΣԽ
        char      cProbabilityFlag;    // ŵ͸ͳƱ־,0ʾδͳƣŵΪ0ͳƣʱŵ͸ΪO1ʾͳƣŵͲΪ0ͳƣʱŵ͸ΪM
        float     fProbability[7];     // ŵ͸(%),1-7ַ͵ĸʣŵ0ͳƸʣδԷŵʽͳƼֻжϳĳһַŵͣ򽫶ӦķŵͼΪ100%0xFFFFFFFFΪδʹñʶ
        int       iFdPhaseNum_m;       // ŵλm,Ƶڱȷֳmʱ
        int       iAmplitude_n;        // ֵn,ֵΧȷֳɸ䣬ֵʾn䡣ַͼΪPRPDάͼnΪMpΪO
        int       iFrequencyCycle_p;   // Ƶp,ƵڵĸַͼΪPRPSάͼpΪMnΪO
        float     f50Relevance;        // 50Hz,һƵзŵź50Hzس̶ȣλΪ%0xFFFFFFFFΪδʹñʶ
        float     f100Relevance;       // 50Hz,һƵзŵź50Hzس̶ȣλΪ%0xFFFFFFFFΪδʹñʶ
        char      cSpectrogramType;    // ַͼͱ־,0ʾPRPDάͼ1ʾPRPSάͼ
        char      cAmplitudeUnit;      // ֵλ,0ʾdBm1ʾmV2%
        float     fMinAmplitude;       // ŵֵޣ0xFFFFFFFFΪδʹñʶ
        float     fMaxAmplitude;       // ŵֵޣ0xFFFFFFFFΪδʹñʶ
        char      szSeparation[4];     // ָ$$$$.
    }ST_CSG_PDFILE_HEAD;

    typedef union
    {
        float f;
        int   i;
    }ST_CSG_DATA;

    // ַͼݶ ¼D.3
    typedef struct {
        ST_CSG_DATA Data;
    }ST_CSG_PD_DATA;


    /*
    * ͨiķϢĽṹ嶨 ¼D.4
    */
    typedef struct {
        char  szGroupName[10];          // ,ƣH2CH4C2H2C2H4C2H6COCO2
        char  cPeakNumber;              // ,j
        float fPeakTime;                // ʱ,λ롰Xᵥλһ
        float fPeakStartTime;           // 忪ʼʱ,λ롰Xᵥλһ
        float fPeakStopTime;            // ʱ,λ롰Xᵥλһ
        float fPeakHigh;                // ,λ롰Yᵥλһ
        float fPeakArea;                // ,λΪYᵥλ͡Xᵥλĳ˻磬YᵥλΪ΢XᵥλΪ룬λΪ΢*
    }ST_YSP_INFO;

    /*
    * ͨϢĽṹ嶨 ¼D.4
    */
    typedef struct {
        char  cChannelPeak_n;         // ͨiķn,ͨiеķn
        ST_YSP_INFO *pstInfo;         // ͨiķϢ,¼ͨinϢͨiĵjΪjjΪ0~n - 1֮ͨiķ0ʼУn
    }ST_CSG_YSP_CHANNEL;
    
    /*
    * ɫͼݸʽ ¼D.4
    */
    typedef struct {
        float     fStandardVersion;     // 淶汾,ʹõͨøʽ淶汾ţҪΪ1.2
        float     fFileVersion;         // ļ汾,߼װóڲʹõİ汾ţ
                                        // 1.000ע淶汾
        short     shSpectrogramCode;    // ͼͱ,01:ַ 02:· 07:ܽͼ
        tint64    ilSpectrogramGenTime; // ͼʱ,YYYYMMDDhhmmss
        char      cTestFileFlag;        // ļ־λ,0ʾļΪõʱļ
                                        // 1ʾ߼װͼļע⣬ܽͼɣͨΪ1
        char      szDeviceName[32];     // 豸,unicode,0x00
        float     fX_t;                 // Xt,ݵʱtڻX
        float     fY_Max;               // Yֵ,ݵֵڻY
        char      cXUnit;               // Xᵥλ,0ʾ루s1ʾ루ms
        char      cYUnit;               // Yᵥλ,0ʾmV1ʾ΢V
        int       iData_k;              // ݵk,ݵkҪͨݵkͬX᳤Ϊt*k
        char      cChannel_m;           // ͨm,ͼеͨm
        ST_CSG_YSP_CHANNEL *pstChannel; // ͨϢ, ¼mͨϢiͨΪͨi,iΪ0~m - 1֮ͨ0ʼУmͨ
        char      szSeparation[4];      // ָ$$$$.
    }ST_CSG_YSPFILE_HEAD;

    // ɫͼݶ ¼D.5
    typedef struct {
        ST_CSG_DATA Data;
    }ST_CSG_YSP_DATA;

    /*
    * ·ͼݶ  D.6
    */
    typedef struct {
        float     fStandardVersion;     // 淶汾,ʹõͨøʽ淶汾ţҪΪ1.2
        float     fFileVersion;         // ļ汾,߼װóڲʹõİ汾ţ
                                        // 1.000ע淶汾
        short     shSpectrogramCode;    // ͼͱ,01:ַ 02:· 07:ܽͼ
        tint64    ilSpectrogramGenTime; // ͼʱ,YYYYMMDDhhmmss
        char      cTestFileFlag;        // ļ־λ,0ʾļΪõʱļ1ʾ߼װü⵽·ж
        char      szDeviceName[32];     // 豸,unicode,0x00
        char      cControl;             // 0ʾеҽ1բȦ    1ʾе2բȦ
                                        // 2ʾÿ1բȦ3ÿ2բȦ
                                        // ͼݵʾеΪ01ֻA
        char      cWaveformType;        // ,0:ʾբ1ȦΣ1:ʾբ2ȦΣ2:ʾբȦ  3:ʾܵΣ4:ʾϣУ
        float     fX_t;                 // Xt,ݵʱtڻX
        float     fY_Max;               // Yֵ,ݵֵڻY
        char      cXUnit;               // Xᵥλ,0ʾ루s1ʾ루ms
        char      cYUnit;               // Yᵥλ,0ʾࣨA
        int       iData_k;              // ݵk,ݵkҪABCݵkͬX᳤Ϊt*k
        char      szSeparation[4];      // ָ$$$$.
    }ST_CSG_DLQFILE_HEAD;

    /*
    * ·ͼͼݶ  D.7
    */
    typedef struct {
        float *pfAWave;      // ,kΪݵֵʾÿݵYֵʵֵеֻA࣬ʱBࡢCನӦʡ
        float *pfBWave;      // 
        float *pfCWave;      // 
    }ST_CSG_DLQ_DATA;

    typedef struct {
        int sno;
        int tme;
        short A1;
        short A2;
        short B1;
        short B2;
        short C1;
        short C2;

        short a1;
        short a2;
        short b1;
        short b2;
        short c1;
        short c2;

        short nsi;
        short crt;
    }ST_COMTRAD_DATA;

#pragma pack (pop)


    void csgIEC61850PdFileParser(ST_FILE61850_LIST &stListFile);
    int  unGenComtrad(char *pfile);

#if defined (__cplusplus)
}
#endif /* defined (__cplusplus) */

#endif /* __HT_IEC_61850_CSGFILE_H */
