/****************************************************************************
** File name    :  HTMmslite.h
** Description  :  define sisco iec mmslite 61850 network protocol api
** Create date  :  2019.09.01
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyright (C) 2002-2019 xi'an huatek, Inc Co., Ltd
** Update record:
** DATE         AUTHER   DESC
** -------------------------------------------------------------------------
** 2019.09.01   Liuyx    first build
****************************************************************************/
#ifndef __HT_SISCO_MMSLITE_61850_H
#define __HT_SISCO_MMSLITE_61850_H

#include "HTGlobal.h"
// window ֻо̬
#if (defined(_WIN32) || defined(_MSC_VER))
    #pragma comment(lib,"iec61850.lib") 
    #pragma comment(lib,"mmslite_ld.lib") 
#endif // _SISCO_MMS_LITE

// Linux ֻж̬
#if (defined(__unix__) || defined(unix) || defined(linux))
#define LIB_SISCO_MMS_61860_FILENAME    "libcosmos_ld.so"   // sisco mmslite so filename
#endif



#pragma pack (push ,1)


#pragma pack (pop)


#if defined (__cplusplus)
extern "C" {
#endif /* defined (__cplusplus) */


void *thread_iec61850_service_proc(void *arg);



#if defined (__cplusplus)
}
#endif /* defined (__cplusplus) */

#endif /* __HT_SISCO_MMSLITE_61850_H */
