/****************************************************************************
** File name    :  HTStrConvert.h
** Description  :  String code convert API
** Create date  :  2018.09.01
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyright (C) 2002-2018 xi'an huatek, Inc Co., Ltd
** Update record:  
** DATE         AUTHER   DESC 
** -------------------------------------------------------------------------               
** 2018.09.01   Liuyx    first build
****************************************************************************/
#ifndef __HT_STR_CONVERT_H
#define __HT_STR_CONVERT_H

#ifdef __cplusplus
extern "C" {
#endif

    int utf8_to_gbk(char *inbuf, size_t inlen, char *outbuf, size_t outlen);
    int gbk_to_utf8(char *inbuf, size_t inlen, char *outbuf, size_t outlen);



#ifdef __cplusplus
}
#endif
#endif // end __HT_STR_CONVERT_H

