/****************************************************************************
** File name    :  HTIEC61850Thread.h
** Description  :  define iec 61850 network protocol api
** Create date  :  2019.09.01
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyright (C) 2002-2019 xi'an huatek, Inc Co., Ltd
** Update record:
** DATE         AUTHER   DESC
** -------------------------------------------------------------------------
** 2019.09.01   Liuyx    first build
****************************************************************************/
#ifndef __HT_LIBIEC_61850_THREAD_H
#define __HT_LIBIEC_61850_THREAD_H
#include "HTGlobal.h"


#if defined (__cplusplus)
extern "C" {
#endif /* defined (__cplusplus) */

    void *thread_cache_proc(void *arg);   // ͬڴ߳
    void *thread_iec61850_getcomtrade_files(void *arg);
    void *thread_iec61850_client_proc(void *arg);
    void *thread_iec61850_manager_proc(void *arg);

    void* thread_database_proc(void * arg);
    /***************************************************************************
    ** function name :  thread_dbalarm_proc
    ** deacription   :  parser thread
    ** parameter     :  none
    ** return code   :  NULL
    ***************************************************************************/
    void* thread_dbalarm_proc(void * arg);


#if defined (__cplusplus)
}
#endif /* defined (__cplusplus) */

#endif /* __HT_LIBIEC_61850_THREAD_H */
