/****************************************************************************
** File name    :  HTType.h
** Description  :  define data type
** Create date  :  2018.09.01
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyright (C) 2002-2018 xi'an huatek, Inc Co., Ltd
** Update record:
** DATE         AUTHER   DESC
** -------------------------------------------------------------------------
** 2018.09.01   Liuyx    first build
****************************************************************************/
#ifndef __HT_TYPE_H
#define __HT_TYPE_H

#ifdef _WIN32
#ifndef tint64
typedef  __int64   tint64;
#endif
#else
#ifndef int64
typedef  long long tint64;
#endif
#endif

#ifdef _WIN32
#ifndef utint64
typedef  unsigned __int64   utint64;
#endif
#else
#ifndef utint64
typedef  unsigned long long utint64;
#endif
#endif

#ifndef f64
typedef  double f64;
#endif
#ifndef f32
typedef  float f32;
#endif

#ifndef s32
typedef  int s32;
#endif

#ifndef s8
typedef signed char s8;
#endif

#ifndef uint
typedef  unsigned int  uint;
typedef  unsigned int  u32;
#endif

#ifndef ulong
typedef  unsigned long ulong;
#endif

#ifndef byte
typedef  unsigned char byte;
typedef  unsigned char u8;
#endif

#ifndef uchar
typedef  unsigned char uchar;
#endif

#ifndef ushort
typedef  unsigned short ushort;
typedef  unsigned short u16;
typedef           short s16;
#endif

#ifdef _WIN32
#ifndef pthread_t 
typedef unsigned long pthread_t;
#endif
/*#else  // Linux
#ifndef pthread_t
typedef pthread_t   pthread_t;   // bits/pthreadtypes.h typedef unsigned long int pthread_t;
#endif
*/
#endif

typedef union 
{
    float f;
    char c[4];
}FLOAT_CONV;


#endif // end __HT_TYPE_H

