#ifndef NETWORK_H
#define NETWORK_H
#include <netinet/in.h>
#include <stdint.h>

typedef struct sockaddr* SP;

typedef struct NetWork
{
    int fd;            // socket
    int type;        // Э SOCK_STREAM/SOCK_DGRAM
    socklen_t len;     // ַ
    struct sockaddr_in addr; // ͨŵַ
}NetWork;

// 
NetWork* open_network(char c_or_s,int type,char* ip,uint16_t port);

// TCPserverר
NetWork* accept_network(NetWork* nw);

// 
int nsend(NetWork* nw,void* buf,uint32_t len);

// 
int nrecv(NetWork* nw,void* buf,uint32_t len);

// ر
void close_network(NetWork* nw);

#endif//NETWORK_H

