/****************************************************************************
** File name    :  FLTGlobal.h
** Description  :  global variable define
** Create date  :  2012.10.10
** Auther by    :  Liuyx
** Version info :  V1.0.01
** Copyrigth By:  xi'an huatek, Inc Co., Ltd
** Update record:  
** DATE         AUTHER   DESC 
** -------------------------------------------------------------------------               
** 2018.09.01   Liuyx    first build
****************************************************************************/
#pragma warning (disable:4786)
#include "HTGlobal.h"

TConfig     g_TConfig ;
int         g_Running;

int         g_seqno;               // ˮ
mutex       g_seq_mutex;           // ˮ 

map<string,ST_IED_CONN_HANDLE>          g_MapIedConn;   // IEDӾ
mutex                                   g_MapIedConn_mutex;

map<string, ST_DEVICE_INFO>             g_map_device;       // װ豸
mutex                                   g_map_device_mutex;

list<ST_FILES_ATTRIB>                   g_list_comtrad_files;  // ¼ļ
mutex                                   g_list_comtrad_files_mutex;

list<ST_DB_BODY>                        g_list_db_body;  // 
mutex                                   g_list_db_body_mutex;

list<ST_DB_WARN>                        g_list_db_warn;  // 
mutex                                   g_list_db_warn_mutex;

map<string, ST_THRES_CONF>              g_thres_conf;    // 񶯴ֵ
mutex                                   g_thres_conf_mutex;

map<string, ST_CONTROL_CONF>            g_ctrl_conf;    // 񶯴Ʋ
mutex                                   g_ctrl_conf_mutex;

map<string, ST_HT_IEC61850>             g_ied;
mutex                                   g_ied_mutex;

map<string, ST_PARAM_BIND>              g_map_parambind;   // icdýڵ󶨹ϵ,key=nodename
mutex                                   g_map_parambind_mutex;   // icdýڵ󶨹ϵ,key=nodename


pthread_t   thread_handle_cache_proc;  // ڴͬ߳̾
pthread_t   thread_handle_database_proc; // ߳̾
pthread_t   thread_handle_dbalarm_proc; // ߳̾

pthread_t   thread_handle_sntpd;       // SNTPУʱ߳̾
pthread_t   thread_handle_sntpc;       // SNTPУʱͻ߳̾

pthread_t   thread_handle_iec61850_manager_proc;
pthread_t   thread_handle_modbus_service;  //Modbus߳̾
pthread_t   thread_handle_modbus_recv;     //Modbus߳̾
pthread_t   thread_handle_modbus_send;     //Modbus߳̾

pthread_t   thread_handle_iec61850_service;  //iec61850߳̾
pthread_t   thread_handle_iec61850_client;     //iec61850߳̾
pthread_t   thread_handle_iec61850_server;     //iec61850߳̾
